; Makes direct access to DTD elements and attributes via symbol values.

; Naming scheme. EN is an element name:
; EN-dtd-element
; EN-dtd-attribute


; DTD list structure accessors:
(define dtd-element-kind-of (make-selector-function 1 "dtd-element-kind-of")) 
(define dtd-element-name-of (make-selector-function 2 "dtd-element-name-of")) ; Both elements and attributes
(define dtd-element-content-model-of (make-selector-function 5 "dtd-element-content-model-of"))
(define dtd-attribute-list-of (make-selector-function 3 "dtd-attribute-list-of"))

(define dtd-attribute-name-of (make-selector-function 1 "dtd-attribute-name-of"))
(define dtd-attribute-type-of (make-selector-function 2 "dtd-attribute-type-of"))
(define dtd-attribute-status-of (make-selector-function 3 "dtd-attribute-status-of"))

(define (make-direct-access-to-dtd dtd-list-structure)
 (let ((global-define (lambda (symbol expr) (eval (list 'define symbol expr)))))
   (for-each 
    (lambda (x)
      (cond ((eq? (dtd-element-kind-of x) 'element)
	     (global-define (dtd-symbol-access-name 'element (dtd-element-name-of x)) (list 'quote x)))
	    ((eq? (dtd-element-kind-of x) 'attribute)
	     (global-define (dtd-symbol-access-name 'attribute (dtd-element-name-of x)) (list 'quote x)))
	    (else 'do-nothing)))
    dtd-list-structure)))

(define (dtd-symbol-access-name kind el-name)
  (cond ((eq? kind 'element) (as-symbol (string-append (as-string el-name) "-dtd-element")))
        ((eq? kind 'attribute) (as-symbol (string-append (as-string el-name) "-dtd-attribute")))
        (else (laml-error "dtd-symbol-access-name: Unknown kind:" kind))))


; ---------------------------------------------------------------------------------------------------

; Return the content model of the elment rooted in ast.
(define (dtd-content-model-of-ast ast)
 (let* ((el-name (ast-element-name ast))
        (symbol (dtd-symbol-access-name 'element el-name))
        (element-structure (eval symbol))
        (content-model (dtd-element-content-model-of element-structure))
       )
   content-model))

(define (dtd-list-constructor-rule? x)
  (and x (list? x) (not (null? x)) (or (eq? (car x) 'zero-or-more) (eq? (car x) 'one-or-more))))
   






